unit FormMain;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.ComCtrls, Vcl.StdCtrls, System.StrUtils, System.NetEncoding,
  Vcl.ExtCtrls, IdBaseComponent, IdComponent, IdTCPConnection, IdTCPClient, IdHTTP, ChqCommon, ChqDES, md5,
  IdAntiFreezeBase, IdAntiFreeze;

type
 TCPUID  = array[1..4] of  Longint;

type
  TFrmMain = class(TForm)
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    EdtUser: TEdit;
    Label1: TLabel;
    EdtPwd: TEdit;
    Label2: TLabel;
    EdtPwdb: TEdit;
    Label3: TLabel;
    EdtQQ: TEdit;
    Label4: TLabel;
    EdtMail: TEdit;
    Label5: TLabel;
    EdtKey: TEdit;
    Label6: TLabel;
    EdtCoode: TEdit;
    Label7: TLabel;
    EdtMobile: TEdit;
    Label8: TLabel;
    Label9: TLabel;
    EdtMibao_wenti: TEdit;
    Label10: TLabel;
    EdtMibao_daan: TEdit;
    EdtExtension: TEdit;
    Label11: TLabel;
    Panel1: TPanel;
    Memo1: TMemo;
    BtnReg: TButton;
    TabSheet2: TTabSheet;
    Label12: TLabel;
    Label13: TLabel;
    Edit1: TEdit;
    Edit2: TEdit;
    Button2: TButton;
    TabSheet3: TTabSheet;
    Label14: TLabel;
    Label15: TLabel;
    Edit3: TEdit;
    Edit4: TEdit;
    Button3: TButton;
    TabSheet4: TTabSheet;
    TabSheet5: TTabSheet;
    Label16: TLabel;
    Label17: TLabel;
    Edit5: TEdit;
    Edit6: TEdit;
    Label18: TLabel;
    Edit7: TEdit;
    Button5: TButton;
    Edit8: TEdit;
    Label20: TLabel;
    Label19: TLabel;
    Label21: TLabel;
    Edit9: TEdit;
    Edit10: TEdit;
    Label22: TLabel;
    Edit11: TEdit;
    Edit12: TEdit;
    Label23: TLabel;
    Button6: TButton;
    Button7: TButton;
    Button8: TButton;
    Button9: TButton;
    IdHTTPPost: TIdHTTP;
    IdAntiFreeze1: TIdAntiFreeze;
    Timer1: TTimer;
    Button1: TButton;
    procedure BtnRegClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure Button8Click(Sender: TObject);
    procedure Button9Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Timer1Timer(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    function HttpPost(Post:string):string;
    procedure GetBSphpSeSsL;
    procedure UserReg;
    procedure UserLogin;
    procedure UserJieKey;
    procedure UserLogout;
    procedure UserChangePwd;
    procedure UserChong;
    procedure GetLgInfo;
    procedure GetVipDate;
    procedure UserTimeOut;
    procedure RemoteLogout;
  end;

const
  CG_ServerUrl='http://app.bsphp.com/AppEn.php?appid=10000001&m=7940ba8d58781bd429c38992a898f509';//ַ
  CG_MutualKey='49cf89dfce8e45d044329180bd6e2d43';//֤ͨkey
  CG_DesKey='GPnGwYgRmPXZTGJF0R';//ͨż
  CG_SoftChkDat='123';//֤


var
  FrmMain: TFrmMain;
  G_BSphpSeSsL:string;

implementation

{$R *.dfm}

function GetStr(sStart,sEnd,InputStr:string):string;
var
pos1,pos2:Integer;
begin
  pos1:=Pos(sStart,InputStr,1);
  pos2:=Pos(sEnd,InputStr,pos1+Length(sStart));
  if (pos1>0) and (pos2>0) then
    Result:=MidStr(InputStr,pos1+Length(sStart),pos2-pos1-Length(sStart))
  else
    Result:='';
end;

function GetSzStr(SzCount:Integer):string;
var
i:Integer;
sStr1:string;
begin
  for i:=1 to SzCount do
  begin
    if i=1 then
      sStr1:=sStr1+Chr(Random(9)+49)
    else
      sStr1:=sStr1+Chr(Random(10)+48);
  end;
  Result:=sStr1;
end;

function GetDesKey8(Key:string):string;//8λdeskey
begin
  Result:=Copy(LowerCase(MD5Print(MD5StringA(AnsiString(Key)))),1,8);
end;

function GetCPUID:Tcpuid; assembler; register;   //ȡCPUϵк
asm
    push ebx                            {Save   affected   register}
    push edi
    mov edi,eax                         {@Result}
    mov eax,0
    Dw  $A20F                           {CPUID   Command}
    Stosd                               {CPUID[1]Ϣ eaxΪCpu1}
    mov eax,ebx
    Stosd                               {CPUID[2]Ϣ ebxΪcpu2}
    mov eax,ecx
    Stosd                               {CPUID[3]Ϣ ecxΪcpu3}
    mov eax,edx
    Stosd                               {CPUID[4]Ϣ edxΪcpu4}
    pop edi                             {Restore   registers}
    pop ebx
end;

function GetCPUIDStr:String;
var
CPUID:TCPUID;
begin
  CPUID:=GetCPUID;
  Result:=IntToHex(CPUID[1],8)+IntToHex(CPUID[2],8)+IntToHex(CPUID[3],8)+IntToHex(CPUID[4],8);
end;

function TFrmMain.HttpPost(Post:string):string;
var
sHtml:string;
data:string;
sstPost,sstHtml:TStringStream;
begin
  IdHTTPPost.Request.UserAgent:='Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; rv:11.0) like Gecko';
  IdHTTPPost.Request.Connection:='Keep-Alive';
  IdHTTPPost.Request.Accept:='text/html, application/xhtml+xml, */*';
  IdHTTPPost.Request.AcceptLanguage:='zh-CN';
  IdHTTPPost.ReadTimeout:=60000;
  IdHTTPPost.Request.ContentType:='application/x-www-form-urlencoded';
  IdHTTPPost.Request.CacheControl:='no-cache';

  sstHtml:=TStringStream.Create('',TEncoding.GetEncoding(65001));


  data:=TNetEncoding.URL.Encode(DESEncryptStrToHex(Post,GetDesKey8(CG_DesKey),TEncoding.UTF8,TEncoding.UTF8,rlCRLF,rlCRLF,nil));
  sstPost:=TStringStream.Create('parameter='+data);

  OutputDebugString(PChar('ͼݰ:'+data));
  OutputDebugString(PChar(':'+GetDesKey8(CG_DesKey)));
       //http://tool.chacuo.net/cryptdes


  try
    try
      IdHTTPPost.Post(CG_ServerUrl,sstPost,sstHtml);
       OutputDebugString(PChar(':' + sstHtml.DataString));

      sHtml:=sstHtml.DataString;
      OutputDebugString(PChar(':'+sHtml));
    except
    end;
  finally
    sstHtml.Free;
    sstPost.Free;
  end;

  //
  Result:=trim(DESDecryptStrFromHex(sHtml,GetDesKey8(CG_DesKey),TEncoding.UTF8,TEncoding.UTF8,rlCRLF,rlCRLF,nil));//des
end;

procedure TFrmMain.GetBSphpSeSsL;
var
sHtml,sPost:string;
begin
  sPost:='api='+'BSphpSeSsL.in'+'&'+
         'date='+FormatDateTime('yyyy-mm-ddhh:nn:ss',Now)+'&'+
         'mutualkey='+CG_MutualKey+'&'+
         'appsafecode='+GetSzStr(9)+'&'+
         'sgin='+''+'&'+
         'md5='+'';
  sHtml:=HttpPost(sPost);
  G_BSphpSeSsL:=GetStr('"data":"','"',sHtml);//ڷʽΪjosn
  Memo1.Lines.Clear;
  Memo1.Lines.Add(sHtml);
end;

procedure TFrmMain.UserReg;
var
sHtml,sPost:string;
begin
  sPost:='api='+'registration.lg'+'&'+
        'BSphpSeSsL='+G_BSphpSeSsL+'&'+
        'date='+FormatDateTime('yyyy-mm-ddhh:nn:ss',Now)+'&'+
        'mutualkey='+CG_MutualKey+'&'+
        'appsafecode='+GetSzStr(9)+'&'+
        'sgin='+''+'&'+
        'md5='+''+'&'+
        'user='+Trim(EdtUser.Text)+'&'+
        'pwd='+Trim(EdtPwd.Text)+'&'+
        'pwdb='+Trim(EdtPwdb.Text)+'&'+
        'qq='+Trim(EdtQQ.Text)+'&'+
        'mail='+Trim(EdtMail.Text)+'&'+
        'key='+Trim(EdtKey.Text)+'&'+
        'coode='+Trim(EdtCoode.Text)+'&'+
        'mobile='+Trim(EdtMobile.Text)+'&'+
        'mibao_wenti='+Trim(EdtMibao_wenti.Text)+'&'+
        'mibao_daan='+Trim(EdtMibao_daan.Text)+'&'+
        'extension='+Trim(EdtExtension.Text);
  sHtml:=HttpPost(sPost);
  Memo1.Lines.Clear;
  Memo1.Lines.Add(sHtml);
end;

procedure TFrmMain.UserLogin;
var
sHtml,sPost:string;
begin
  sPost:='api='+'login.lg'+'&'+
        'BSphpSeSsL='+G_BSphpSeSsL+'&'+
        'date='+FormatDateTime('yyyy-mm-ddhh:nn:ss',Now)+'&'+
        'mutualkey='+CG_MutualKey+'&'+
        'appsafecode='+GetSzStr(9)+'&'+
        'sgin='+''+'&'+
        'md5='+''+'&'+
        'user='+Trim(Edit1.Text)+'&'+
        'pwd='+Trim(Edit2.Text)+'&'+
        'key='+''+'&'+
        'maxoror='+Copy(LowerCase(MD5Print(MD5StringA(AnsiString(GetCPUIDStr)))),1,8)+'&'+
        'coode='+'';
  sHtml:=HttpPost(sPost);
  if Pos(CG_SoftChkDat,sHtml)>0 then//¼ɹʼ
  begin
    Button2.Enabled:=False;
    Timer1.Enabled:=True;
  end;
  Memo1.Lines.Clear;
  Memo1.Lines.Add(sHtml);
end;

procedure TFrmMain.UserJieKey;
var
sHtml,sPost:string;
begin
  sPost:='api='+'jiekey.lg'+'&'+
        'BSphpSeSsL='+G_BSphpSeSsL+'&'+
        'date='+FormatDateTime('yyyy-mm-ddhh:nn:ss',Now)+'&'+
        'mutualkey='+CG_MutualKey+'&'+
        'appsafecode='+GetSzStr(9)+'&'+
        'sgin='+''+'&'+
        'md5='+''+'&'+
        'user='+Trim(Edit3.Text)+'&'+
        'pwd='+Trim(Edit4.Text);
  sHtml:=HttpPost(sPost);
  Memo1.Lines.Clear;
  Memo1.Lines.Add(sHtml);
end;

procedure TFrmMain.UserLogout;
var
sHtml,sPost:string;
begin
  sPost:='api='+'cancellation.lg'+'&'+
        'BSphpSeSsL='+G_BSphpSeSsL+'&'+
        'date='+FormatDateTime('yyyy-mm-ddhh:nn:ss',Now)+'&'+
        'mutualkey='+CG_MutualKey+'&'+
        'appsafecode='+GetSzStr(9)+'&'+
        'sgin='+''+'&'+
        'md5='+'';
  sHtml:=HttpPost(sPost);
  Memo1.Lines.Clear;
  Memo1.Lines.Add(sHtml);
end;

procedure TFrmMain.UserChangePwd;
var
sHtml,sPost:string;
begin
  sPost:='api='+'password.lg'+'&'+
        'BSphpSeSsL='+G_BSphpSeSsL+'&'+
        'date='+FormatDateTime('yyyy-mm-ddhh:nn:ss',Now)+'&'+
        'mutualkey='+CG_MutualKey+'&'+
        'appsafecode='+GetSzStr(9)+'&'+
        'sgin='+''+'&'+
        'md5='+''+'&'+
        'user='+Trim(Edit5.Text)+'&'+
        'pwd='+Trim(Edit6.Text)+'&'+
        'pwda='+Trim(Edit7.Text)+'&'+
        'pwdb='+Trim(Edit8.Text)+'&'+
        'img='+'';
  sHtml:=HttpPost(sPost);
  Memo1.Lines.Clear;
  Memo1.Lines.Add(sHtml);
end;

procedure TFrmMain.UserChong;
var
sHtml,sPost:string;
begin
  sPost:='api='+'chong.lg'+'&'+
        'BSphpSeSsL='+G_BSphpSeSsL+'&'+
        'date='+FormatDateTime('yyyy-mm-ddhh:nn:ss',Now)+'&'+
        'mutualkey='+CG_MutualKey+'&'+
        'appsafecode='+GetSzStr(9)+'&'+
        'sgin='+''+'&'+
        'md5='+''+'&'+
        'user='+Trim(Edit9.Text)+'&'+
        'userpwd='+Trim(Edit10.Text)+'&'+
        'userset='+'1'+'&'+
        'ka='+Trim(Edit11.Text)+'&'+
        'pwd='+Trim(Edit12.Text);
  sHtml:=HttpPost(sPost);
  Memo1.Lines.Clear;
  Memo1.Lines.Add(sHtml);
end;

procedure TFrmMain.GetLgInfo;
var
sHtml,sPost:string;
begin
  sPost:='api='+'lginfo.lg'+'&'+
        'BSphpSeSsL='+G_BSphpSeSsL+'&'+
        'date='+FormatDateTime('yyyy-mm-ddhh:nn:ss',Now)+'&'+
        'mutualkey='+CG_MutualKey+'&'+
        'appsafecode='+GetSzStr(9)+'&'+
        'sgin='+''+'&'+
        'md5='+'';
  sHtml:=HttpPost(sPost);
  Memo1.Lines.Clear;
  Memo1.Lines.Add(sHtml);
end;

procedure TFrmMain.GetVipDate;
var
sHtml,sPost:string;
begin
  sPost:='api='+'vipdate.lg'+'&'+
        'BSphpSeSsL='+G_BSphpSeSsL+'&'+
        'date='+FormatDateTime('yyyy-mm-ddhh:nn:ss',Now)+'&'+
        'mutualkey='+CG_MutualKey+'&'+
        'appsafecode='+GetSzStr(9)+'&'+
        'sgin='+''+'&'+
        'md5='+'';
  sHtml:=HttpPost(sPost);
  Memo1.Lines.Clear;
  Memo1.Lines.Add(sHtml);
end;

procedure TFrmMain.UserTimeOut;
var
sHtml,sPost:string;
begin
  sPost:='api='+'timeout.lg'+'&'+
        'BSphpSeSsL='+G_BSphpSeSsL+'&'+
        'date='+FormatDateTime('yyyy-mm-ddhh:nn:ss',Now)+'&'+
        'mutualkey='+CG_MutualKey+'&'+
        'appsafecode='+GetSzStr(9)+'&'+
        'sgin='+''+'&'+
        'md5='+'';
  sHtml:=HttpPost(sPost);
  Memo1.Lines.Clear;
  Memo1.Lines.Add(sHtml);
end;

procedure TFrmMain.RemoteLogout;
var
sHtml,sPost:string;
begin
  sPost:='api='+'remotecancellation.lg'+'&'+
        'BSphpSeSsL='+G_BSphpSeSsL+'&'+
        'date='+FormatDateTime('yyyy-mm-ddhh:nn:ss',Now)+'&'+
        'mutualkey='+CG_MutualKey+'&'+
        'appsafecode='+GetSzStr(9)+'&'+
        'sgin='+''+'&'+
        'md5='+''+'&'+
        'user='+Trim(Edit1.Text)+'&'+
        'pwd='+Trim(Edit2.Text);
  sHtml:=HttpPost(sPost);
  Memo1.Lines.Clear;
  Memo1.Lines.Add(sHtml);
end;

procedure TFrmMain.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  UserLogout;
end;

procedure TFrmMain.FormCreate(Sender: TObject);
begin
  Randomize;
  GetBSphpSeSsL;
end;

procedure TFrmMain.Timer1Timer(Sender: TObject);
begin
  UserTimeOut;
end;

procedure TFrmMain.BtnRegClick(Sender: TObject);
begin
  UserReg;
end;

procedure TFrmMain.Button1Click(Sender: TObject);
begin
  RemoteLogout;
end;

procedure TFrmMain.Button2Click(Sender: TObject);
begin
  UserLogin;
end;

procedure TFrmMain.Button3Click(Sender: TObject);
begin
  UserJieKey;
end;

procedure TFrmMain.Button5Click(Sender: TObject);
begin
  UserChangePwd;
end;

procedure TFrmMain.Button6Click(Sender: TObject);
begin
  UserChong;
end;

procedure TFrmMain.Button7Click(Sender: TObject);
begin
  GetLgInfo;
end;

procedure TFrmMain.Button8Click(Sender: TObject);
begin
  GetVipDate;
end;

procedure TFrmMain.Button9Click(Sender: TObject);
begin
  UserTimeOut
end;

end.
